#include "TcpSocket.hpp"
#include "NetConst.hpp"
#include "sql.hpp"
#include "values/DnaManager.hpp"
#include <iostream>

#include <map>

// use pthread rw_lock to lock db so you can safy clone .db file

typedef std::vector<NetUnit> NetList;
typedef std::vector<NetList> UserList;

std::map<uint64_t, UserList> data;

// When a new client connected:
void call(int sock, sockaddr_in newSocketInfo)
{
  std::cout << "new User" << std::endl;

  uint64_t conf, id;
  Message message;

  TcpSocket::recvt(sock, &conf, sizeof(conf));
  TcpSocket::recvt(sock, &id, sizeof(id));

  if (conf != StartHeader)
  {
    TcpSocket::closet(sock);
    return;
  }

  if (id == 0)
  {
    printf("ID ERROR\n");
    return;
  }

  auto found = data.find(id);
  if (found == data.end())
  {
    UserList list;
    data.insert(std::pair<uint64_t, UserList>(id, list));
    found = data.find(id);
  }

  while (true)
  {
    size_t gen = found->second.size();

    message.mess = Mess::REQ_SEND_GEN;
    message.data = gen;

    TcpSocket::sendt(sock, &message, sizeof(Message));
    TcpSocket::recvt(sock, &message, sizeof(Message));

    if (message.mess == Mess::RES_NO)
    {
      break;
    }

    NetList list;
    list.resize(NUM_PER_GEN);

    TcpSocket::recvt(sock, list.data(), NUM_PER_GEN * sizeof(NetUnit));
    found->second.push_back(list);
  }

  printf("id: %ld, size: %ld\n", id, found->second.size());

  std::cout << "del USER" << std::endl;
  TcpSocket::closet(sock);
}

int main()
{
  sql::init();
  // Bind the server to a port.
  int err = TcpSocket::listent("0.0.0.0", 8888, call);
  if (err < 0)
  {
    printf("ERROR %d", err);
    return 0;
  }

  return 0;
}